/**
 * Created by coolbong on 2015-05-28.
 */


/** number */
if (typeof Number.prototype.toHexString != 'function') {
    Number.prototype.toHexString = function (num) {
        // figure means bytes length
        var figure;
        if (num === undefined) {
            figure = 1 * 2; // num is 1
        } else {
            figure = num * 2;
        }

        var hex = this.toString(16).toUpperCase();

        if (hex.length >= figure) {
            return hex.right(figure);
        } else {
            return new Array(figure - hex.length + 1).join('0') + hex;
        }

    };
}

if (typeof Number.prototype.toBuffer != 'function') {
    Number.prototype.toBuffer = function () {

        var str = this.toString(16);
        if ((str.length & 1) != 0) {
            str = str + '0';
        }

        return new Buffer(str, 'hex');
    };
}

/** string */
if (typeof String.prototype.chunk != 'function') {
    String.prototype.chunk = function (n) {
        var ret = [];
        for (var i = 0, len = this.length; i < len; i += n) {
            ret.push(this.substr(i, n))
        }
        return ret
    };
}

//fixme
if (typeof String.prototype.toHexString != 'function') {
    String.prototype.toHexString = function () {
        return this;
    };
}

//"{0}".format('hello') => "hello"
if (typeof String.prototype.format != 'function') {
    String.prototype.format = function () {
        var args = arguments;
        return this.replace(/{(\d+)}/g, function (match, number) {
            return typeof args[number] != 'undefined' ? args[number] : match;
        });
    };
}

if (typeof String.prototype.startsWith != 'function') {
    String.prototype.startsWith = function (str) {
        return this.slice(0, str.length) == str;
    };
}

if (typeof String.prototype.endsWith != 'function') {
    String.prototype.endsWith = function (str) {
        return this.slice(-str.length) == str;
    };
}

if (typeof String.prototype.toBoolean != 'function') {
    String.prototype.toBoolean = function () {
        return !!JSON.parse(String(this).toLowerCase());
    };
}

if (typeof String.prototype.strip != 'function') {
    String.prototype.strip = function () {
        return this.replace(/\s+/g, '');
    };
}

if (typeof String.prototype.left != 'function') {
    String.prototype.left = function (num) {
        return this.slice(0, num);
    };
}

if (typeof String.prototype.right != 'function') {
    String.prototype.right = function (num) {
        return this.slice(this.length - num, this.length);
    };
}

if (typeof String.prototype.toJavaBytes != 'function') {
    String.prototype.toJavaBytes = function (prefix) {
        var ret = '';
        if (prefix !== undefined) {
            ret = prefix
        }
        return ret + '{ (byte)0x' + this.chunk(2).join(', (byte)0x') + ' };';
    };
}

if (typeof String.prototype.toBuffer != 'function') {
    String.prototype.toBuffer = function () {
        var tmp = this.replace(/\s+/g, '');
        return new Buffer(tmp, 'hex');
    };
}


//FIXME need fill api
if (typeof String.prototype.fill != 'function') {
    /**
     *
     * @param {number} num
     * @param {string|number} value
     * @param {boolean} [fill left]
     * @returns {string}
     */
    String.prototype.fill = function (num, value, left) {
        value = value || 0; // default value : 0
        left = left || false; // default right padding
        var padding = Array(num+1).join(value);
        if (left == true) {
            return padding + this;
        } else {
            return this + padding;
        }
    };
}


/** Buffer */

if (typeof Buffer.prototype.readUIntBE != 'function') {
    Buffer.prototype.readUIntBE = function (offset, byteLength, noAssert) {
        offset = offset >>> 0;
        byteLength = byteLength >>> 0;
        if (!noAssert) {
            if (offset + byteLength > this.length) {
                throw new RangeError('index out of range');
            }
            //checkOffset(offset, byteLength, this.length);
        }

        var val = this[offset + --byteLength];
        var mul = 1;
        while (byteLength > 0 && (mul *= 0x100)) {
            val += this[offset + --byteLength] * mul;
        }

        return val;
    };
}

if (typeof Buffer.prototype.writeUIntBE != 'function') {
    Buffer.prototype.writeUIntBE = function (value, offset, byteLength, noAssert) {
        value = +value;
        offset = offset >>> 0;
        byteLength = byteLength >>> 0;
        if (!noAssert) {
            if (value > Math.pow(2, 8 * byteLength) || value < 0)
                throw new TypeError('value is out of bounds');
            if (offset + byteLength > this.length)
                throw new RangeError('index out of range');
        }

        var i = byteLength - 1;
        var mul = 1;
        this[offset + i] = value;
        while (--i >= 0 && (mul *= 0x100))
            this[offset + i] = (value / mul) >>> 0;

        return offset + byteLength;
    };
}

if (typeof Buffer.prototype.readDoubleBE != 'function') {
    Buffer.prototype.readDoubleBE = function readDoubleBE(offset, noAssert) {
        offset = offset >>> 0;
        if (!noAssert)
            checkOffset(offset, 8, this.length);
        return internal.readDoubleBE(this, offset);
    };
}


if (typeof Buffer.prototype.toHexString != 'function') {
    Buffer.prototype.toHexString = function () {
        return this.toString('hex').toUpperCase();
    };
}

if (typeof Buffer.prototype.left != 'function') {
    Buffer.prototype.left = function (num) {
        return this.slice(0, num);
    };
}

if (typeof Buffer.prototype.right != 'function') {
    Buffer.prototype.right = function (num) {
        return this.slice(this.length - num, this.length);
    };
}

if (typeof Buffer.prototype.getShort != 'function') {
    Buffer.prototype.getShort = function (offset) {
        return this.readUInt16BE(offset);
    };
}

if (typeof Buffer.prototype.setShort != 'function') {
    Buffer.prototype.setShort = function (offset, value) {
        return this.writeUInt16BE(offset, value);
    };
}
if (typeof Buffer.prototype.increase != 'function') {
    Buffer.prototype.increase = function (num) {
        var init_val = num;

        for (var i = (this.length - 1); i >= 0; i--) {
            init_val += this[i];
            this[i] = init_val;
            init_val = (init_val > 255) ? 1 : 0;
        }
    };
}

if (typeof Buffer.prototype.toJavaBytes != 'function') {
    Buffer.prototype.toJavaBytes = function (prefix) {
        var ret = '';
        if (prefix !== undefined) {
            ret = prefix
        }
        return ret + '{ (byte)0x' + this.toHexString().chunk(2).join(', (byte)0x') + ' };';
    };
}

if (typeof Buffer.prototype.toJavaShorts != 'function') {
    Buffer.prototype.toJavaShorts = function (prefix) {
        var ret = '';
        if (prefix !== undefined) {
            ret = prefix
        }
        return ret + '{ (short)0x' + this.toHexString().chunk(4).join(', (short)0x') + ' };';
    };
}

function main() {
    var pinheader = '241234';
    var len = 14 - pinheader.length;
    var pin = pinheader.fill(len, 'f');
    //var data = '241234'.fill(6, 'f');
    console.log(pin);
    var aid = 'A0000000035010';
    var buf = aid.toBuffer();
    console.log(buf.toJavaShorts());
}

//main();